class IntersectionService {
    constructor() {
        this.intersectionsMap = new Map()
    }

    /**
     * 
     * @param {[]} intersections 
     */
    addIntersections(intersections) {
        const key = intersections.map((intersection) => {
            return `r_${intersection.r.id}_s_${intersection.s.id}`;
        });
        if (this.intersectionsMap.has(key)) {
            this.intersectionsMap.get(key).forEach((x, i) => intersections[i] = x.id);
            delete this.intersectionsMap.get(key);
            this.intersectionsMap.delete(key);
        }
        this.intersectionsMap.set(key, intersections);
        return intersections;
    }
}
export const intersectionService = new IntersectionService();